searchData={"items":[{"type":"module","title":"ExPBKDF2","doc":"Rust NIf for [Password-Based Key Derivation Function v2 (PBKDF2)](https://en.wikipedia.org/wiki/PBKDF2). It uses the [pbkdf2](https://github.com/RustCrypto/password-hashes/tree/master/pbkdf2) rust library.","ref":"ExPBKDF2.html"},{"type":"function","title":"ExPBKDF2.generate_salt/0","doc":"Generate a random salt\n\nExamples\n\n    iex> salt = ExPBKDF2.generate_salt()\n    iex> byte_size(salt)\n    16","ref":"ExPBKDF2.html#generate_salt/0"},{"type":"function","title":"ExPBKDF2.pbkdf2/2","doc":"Hash the provided password\n\nIt accepts a map with optional parameters:\n\n- `:salt` - if it's not set, it will be generated\n- `:alg` - the hashing algorithm to be used. it can be `\"sha512\"` or `\"sha256\"`. Default value is `\"sha512\"`\n- `:iterations` - the number of iterations. The default value is 4096\n- `:length` - the length of the result. The default value is 64\n\nExamples\n\n    iex> opts = %{salt: \"salt\", alg: \"sha256\", iterations: 4096, length: 32}\n    iex> ExPBKDF2.pbkdf2(\"password\", opts)\n    <<197, 228, 120, 213, 146, 136, 200, 65, 170, 83, 13, 182, 132, 92, 76, 141, 150, 40, 147, 160, 1, 206, 78, 17, 164, 150, 56, 115, 170, 152, 19, 74>>","ref":"ExPBKDF2.html#pbkdf2/2"},{"type":"function","title":"ExPBKDF2.verify/3","doc":"Verify the provided hash\n\nIt accepts three parameters:\n\n- hash - hash generated with pbkdf2\n- password - used password\n- optional parameters map - it's the same as options for `pbkdf2/2`. If this parameter is not passed, it's assumed that hash is already in the PHC string format\n\nExamples\n\n    iex> hash = <<197, 228, 120, 213, 146, 136, 200, 65, 170, 83, 13, 182, 132, 92, 76, 141, 150, 40, 147, 160, 1, 206, 78, 17, 164, 150, 56, 115, 170, 152, 19, 74>>\n    iex> opts = %{salt: \"salt\", alg: \"sha256\", iterations: 4096, length: 32}\n    iex> ExPBKDF2.verify(hash, \"password\", opts)\n    true","ref":"ExPBKDF2.html#verify/3"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}